
_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;air_rifle.c,14 :: 		void interrupt()
;air_rifle.c,17 :: 		if(C1IF_bit==1)
	BTFSS      C1IF_bit+0, 5
	GOTO       L_interrupt0
;air_rifle.c,20 :: 		C1IE_bit=0; // disable comparator interrupt
	BCF        C1IE_bit+0, 5
;air_rifle.c,21 :: 		C1IF_bit=0; // clear flag
	BCF        C1IF_bit+0, 5
;air_rifle.c,22 :: 		TMR0=tmr0_start; // load timer with starting value
	MOVF       _tmr0_start+0, 0
	MOVWF      TMR0+0
;air_rifle.c,23 :: 		T0IF_bit=0; // clear flag
	BCF        T0IF_bit+0, 2
;air_rifle.c,24 :: 		T0IE_bit=1; // enable timer interrupt
	BSF        T0IE_bit+0, 5
;air_rifle.c,25 :: 		} else
	GOTO       L_interrupt1
L_interrupt0:
;air_rifle.c,28 :: 		T0IE_bit=0; // disable interrupt
	BCF        T0IE_bit+0, 5
;air_rifle.c,29 :: 		T0IF_bit=0; // clear flag
	BCF        T0IF_bit+0, 2
;air_rifle.c,30 :: 		PORTC.B0=1; // set output high
	BSF        PORTC+0, 0
;air_rifle.c,31 :: 		delay_us(50); // give delay to ensure trigger
	MOVLW      76
	MOVWF      R13+0
L_interrupt2:
	DECFSZ     R13+0, 1
	GOTO       L_interrupt2
	NOP
;air_rifle.c,32 :: 		PORTC.B0=0; // set output low
	BCF        PORTC+0, 0
;air_rifle.c,33 :: 		C1IF_bit=0; // clear flag
	BCF        C1IF_bit+0, 5
;air_rifle.c,34 :: 		C1IE_bit=1; // enable comparator interrupt
	BSF        C1IE_bit+0, 5
;air_rifle.c,35 :: 		}
L_interrupt1:
;air_rifle.c,36 :: 		}
L_end_interrupt:
L__interrupt10:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _interrupt

_init:

;air_rifle.c,39 :: 		void init()
;air_rifle.c,42 :: 		ANSEL=0b00100011; // RA0,1 & RC1 as inputs
	MOVLW      35
	MOVWF      ANSEL+0
;air_rifle.c,43 :: 		ANSELH=0;
	CLRF       ANSELH+0
;air_rifle.c,44 :: 		TRISA.B0=1; // C1IN+
	BSF        TRISA+0, 0
;air_rifle.c,45 :: 		TRISA.B1=1; // C1IN0-
	BSF        TRISA+0, 1
;air_rifle.c,46 :: 		TRISA.B2=0; // C1OUT (monitor)
	BCF        TRISA+0, 2
;air_rifle.c,47 :: 		TRISC.B0=0; // Trigger output
	BCF        TRISC+0, 0
;air_rifle.c,48 :: 		PORTC.B0=0;
	BCF        PORTC+0, 0
;air_rifle.c,49 :: 		TRISC.B1=1; // potentiometer input
	BSF        TRISC+0, 1
;air_rifle.c,52 :: 		ADCON0=0b00010101;
	MOVLW      21
	MOVWF      ADCON0+0
;air_rifle.c,53 :: 		ADCON1=0b00100000;
	MOVLW      32
	MOVWF      ADCON1+0
;air_rifle.c,56 :: 		OPTION_REG=0b10000011;
	MOVLW      131
	MOVWF      OPTION_REG+0
;air_rifle.c,59 :: 		CM1CON0=0b10100000;
	MOVLW      160
	MOVWF      CM1CON0+0
;air_rifle.c,60 :: 		delay_us(100); // delay to give inputs time to settle
	MOVLW      153
	MOVWF      R13+0
L_init3:
	DECFSZ     R13+0, 1
	GOTO       L_init3
	NOP
;air_rifle.c,63 :: 		T0IF_bit=0; // clear flags
	BCF        T0IF_bit+0, 2
;air_rifle.c,64 :: 		C1IF_bit=0; // clear flags
	BCF        C1IF_bit+0, 5
;air_rifle.c,65 :: 		T0IE_bit=0; // don't enable timer yet
	BCF        T0IE_bit+0, 5
;air_rifle.c,66 :: 		C1IE_bit=1; // enable comparator interrupt
	BSF        C1IE_bit+0, 5
;air_rifle.c,67 :: 		PEIE_bit=1; // enable ext. interrupts
	BSF        PEIE_bit+0, 6
;air_rifle.c,68 :: 		GIE_bit=1; // enable global interrupts
	BSF        GIE_bit+0, 7
;air_rifle.c,69 :: 		}
L_end_init:
	RETURN
; end of _init

_main:

;air_rifle.c,71 :: 		void main()
;air_rifle.c,74 :: 		init();
	CALL       _init+0
;air_rifle.c,78 :: 		while(1)
L_main4:
;air_rifle.c,80 :: 		ADCON0.B1=1; // start conversion
	BSF        ADCON0+0, 1
;air_rifle.c,81 :: 		while(ADCON0.B1==1){} // wait until conversion completes
L_main6:
	BTFSS      ADCON0+0, 1
	GOTO       L_main7
	GOTO       L_main6
L_main7:
;air_rifle.c,82 :: 		tmr0_start=255-ADRESH; // assign result to tmr0_start
	MOVF       ADRESH+0, 0
	SUBLW      255
	MOVWF      _tmr0_start+0
;air_rifle.c,83 :: 		delay_ms(100); // delay before next loop
	MOVLW      3
	MOVWF      R11+0
	MOVLW      87
	MOVWF      R12+0
	MOVLW      109
	MOVWF      R13+0
L_main8:
	DECFSZ     R13+0, 1
	GOTO       L_main8
	DECFSZ     R12+0, 1
	GOTO       L_main8
	DECFSZ     R11+0, 1
	GOTO       L_main8
;air_rifle.c,84 :: 		}
	GOTO       L_main4
;air_rifle.c,86 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
